Name:       fusioninventory-agent
Version:    2.3.16
Release:    2%{?dist}
Summary:    FusionInventory agent
License:    GPLv2+
Group:  Applications/System
URL:        http://www.fusioninventory.org
Source0:    http://forge.fusioninventory.org/attachments/download/1771/FusionInventory-Agent-%{version}.tar.gz
Patch0:	    FusionInventory-Agent-2.3.16-libvirt-ovirt.patch

%if 0%{?el6}
Source1:    %{name}.init
%else
Source2:    %{name}.service
BuildRequires: systemd
%endif

%if 0%{?fedora} >= 15
Source3:    %{name}.service
BuildRequires: systemd
%endif

BuildArch:  noarch
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(File::Which)
BuildRequires: perl(HTTP::Server::Simple)
BuildRequires: perl(IO::Capture::Stderr)
BuildRequires: perl(IO::Socket::SSL)
BuildRequires: perl(IPC::Run)
BuildRequires: perl(JSON)
BuildRequires: perl(LWP)
BuildRequires: perl(LWP::Protocol::https)
BuildRequires: perl(Net::IP)
BuildRequires: perl(Net::SNMP)
BuildRequires: perl(POE::Component::Client::Ping)
BuildRequires: perl(Socket::GetAddrInfo)
BuildRequires: perl(Test::Deep)
BuildRequires: perl(Test::Exception)
BuildRequires: perl(Test::HTTP::Server::Simple)
BuildRequires: perl(Test::MockModule)
BuildRequires: perl(Test::MockObject)
BuildRequires: perl(Test::NoWarnings)
BuildRequires: perl(Text::Template)
BuildRequires: perl(UNIVERSAL::require)
BuildRequires: perl(XML::TreePP)
Requires:  perl(Proc::Daemon)
Requires:  perl(Proc::PID::File)
Requires:  perl(Socket::GetAddrInfo)
Requires:  perl(Net::NBName)
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}

Obsoletes:  perl-FusionInventory-Agent =< 2.2.7
Obsoletes:  perl-FusionInventory-Agent-Task-Network =< 1.0.2
Obsoletes:  perl-FusionInventory-Agent-Task-ESX =< 2.2.1
Obsoletes:  perl-FusionInventory-Agent-Task-Deploy =< 2.0.4

%description
The fusioninventory agent is a generic agent, running on each managed node. It
can perform a certain number of tasks, either according to its own execution
plan, or as requested from a central control server, such as GLPI server with
fusioninventory plugin.

This package contains only the agent itself. Additional task packages are
needed for effective usage.

%package task-inventory
Summary:  Local inventory support for FusionInventory agent
License:  GPL
Group:  Applications/System
Requires:   %{name} = %{version}-%{release}

%description task-inventory
This package provides local inventory support for FusionInventory agent:
- the inventory task allows the agent to extract various hardware and software
  information on its host
  
Additional optional packages:
- perl-Net-CUPS
- perl-Parse-EDID

%package task-wakeonlan
Summary:    Wake-on-lan support for FusionInventory agent
License:    GPL
Group:  Applications/System
Requires:   %{name} = %{version}-%{release}

%description task-wakeonlan
This package provides wake-on-lan support for FusionInventory agent:
- the wakeonlan task allows the agent to send wake-on-lan packet to another
  host on the same network
  
Additional optional packages:
- perl-Net-Write

%package task-network
Summary:    Network discovery and inventory support for FusionInventory agent
License:    GPL
Group:  Applications/System
Requires:   %{name} = %{version}-%{release}

%description task-network
This package provides network support for FusionInventory agent:
- the NetDiscovery task allows the agent to scan the network to find remote
  devices, through nmap, NetBios or SNMP, and to identify them
- the NetInventory task allows the agent to extract various information from
  a remote device through SNMP protocol
  
Additional optional packages:
- perl-Net-NBName
- nmap

%package task-esx
Summary:    ESX inventory support for FusionInventory agent
License:    GPL
Group:  Applications/System
Requires:   %{name} = %{version}-%{release}

%description task-esx
This package provides ESX support for FusionInventory agent:
- the ESX task allows the agent to perform remote inventory of ESX, ESXi,
  vCenter server using the SOAP interface

%package task-deploy
Summary:    Software deployement support for FusionInventory agent
License:    GPL
Group:  Applications/System
Requires:  %{name} = %{version}-%{release}
Requires:  perl(Archive::Extract)

%description task-deploy
This package provides software deployement support for FusionInventory agent:
- the deploy task allows the agent to perform software installation on its host

%prep
%setup -q -n FusionInventory-Agent-%{version}
%patch0 -p1

# centos 5
cat << \EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* |\
    sed -e '/perl(FusionInventory::/d' |\
    sed -e '/perl(Win32/d'
EOF

cat << \EOF > %{name}-prov
#!/bin/sh
%{__perl_provides} $* |\
    sed -e '/perl(FusionInventory::/d'
EOF

%global __perl_provides %{_builddir}/FusionInventory-Agent-%{version}/%{name}-prov
chmod +x %{__perl_provides}

%global __perl_requires %{_builddir}/FusionInventory-Agent-%{version}/%{name}-req
chmod +x %{__perl_requires}

# centos 6
%{?filter_from_requires: %filter_from_provides /perl(FusionInventory::/d}
%{?filter_from_requires: %filter_from_requires /perl(Win32/d}
%{?filter_from_requires: %filter_from_requires /perl(FusionInventory::/d}
%{?perl_default_filter}

%build
%__perl Makefile.PL \
    PREFIX=%{_prefix} \
    SYSCONFDIR=%{_sysconfdir}/fusioninventory \
    LOCALSTATEDIR=%{_localstatedir}/lib/fusioninventory
make

%install
rm -rf  %{buildroot}
make install DESTDIR=%{buildroot}

# init script configuration file
install -d -m 755 %{buildroot}%{_sysconfdir}/sysconfig
cat > %{buildroot}%{_sysconfdir}/sysconfig/fusioninventory-agent <<EOF
# fusioninventory agent options
FUSINVOPT="--httpd-trust 127.0.0.1"
EOF

install -d -m 755 %{buildroot}%{_sysconfdir}/cron.daily
cat > %{buildroot}%{_sysconfdir}/cron.daily/fusioninventory-agent <<EOF
#!/bin/sh
. /etc/sysconfig/fusioninventory-agent
%{_bindir}/fusioninventory-agent $OPTIONS > /dev/null 2>&1
EOF
chmod 755 %{buildroot}%{_sysconfdir}/cron.daily/fusioninventory-agent

install -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d
cat > %{buildroot}%{_sysconfdir}/logrotate.d/fusioninventory-agent <<EOF
%{_localstatedir}/log/%{name}/*.log {
    compress
    notifempty
    missingok
}
EOF

%if 0%{?el6}
install -d -m 755 %{buildroot}%{_initrddir}
install -m 755 %{SOURCE1} %{buildroot}%{_initrddir}/fusioninventory-agent
%else
# Install systemd service files
mkdir -p %{buildroot}%{_unitdir}/
install -p -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/%{name}.service
%endif

%if 0%{?fedora} >= 15
# Install systemd service files
mkdir -p %{buildroot}%{_unitdir}/
install -p -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}.service
%endif

install -d -m 755 %{buildroot}%{_localstatedir}/log/%{name}
install -d -m 755 %{buildroot}%{_localstatedir}/lib/%{name}

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc Changes THANKS LICENSE README
%{_bindir}/fusioninventory-agent
%{_bindir}/fusioninventory-injector
%{_mandir}/man1/fusioninventory-agent.1*
%{_mandir}/man1/fusioninventory-injector.1*
%{_localstatedir}/log/fusioninventory-agent
%{_localstatedir}/lib/fusioninventory-agent
%{_datadir}/fusioninventory
%dir %{_sysconfdir}/fusioninventory
%config(noreplace) %{_sysconfdir}/fusioninventory/agent.cfg
%config(noreplace) %{_sysconfdir}/logrotate.d/fusioninventory-agent
%config(noreplace) %{_sysconfdir}/cron.daily/fusioninventory-agent
%config(noreplace) %{_sysconfdir}/sysconfig/fusioninventory-agent
%if 0%{?el6}
%{_initrddir}/fusioninventory-agent
%else
%{_unitdir}/%{name}.service
%endif
%if 0%{?fedora} >= 18
%{_unitdir}/%{name}.service
%endif
%dir %{_datadir}/fusioninventory/lib/FusionInventory/Agent/Task
%exclude %{_datadir}/fusioninventory/lib/FusionInventory/Agent/Task
%exclude %{_datadir}/fusioninventory/lib/FusionInventory/Agent/SNMP.pm
%exclude %{_datadir}/fusioninventory/lib/FusionInventory/Agent/SNMP
%exclude %{_datadir}/fusioninventory/lib/FusionInventory/Agent/SOAP

%files task-inventory
%defattr(-,root,root)
%{_bindir}/fusioninventory-inventory
%{_mandir}/man1/fusioninventory-inventory.1*
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/Task/Inventory.pm
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/Task/Inventory

%files task-wakeonlan
%defattr(-,root,root)
%{_bindir}/fusioninventory-wakeonlan
%{_mandir}/man1/fusioninventory-wakeonlan.1*
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/Task/WakeOnLan.pm

%files task-network
%defattr(-,root,root)
%{_bindir}/fusioninventory-netdiscovery
%{_bindir}/fusioninventory-netinventory
%{_mandir}/man1/fusioninventory-netdiscovery.1*
%{_mandir}/man1/fusioninventory-netinventory.1*
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/Task/NetInventory.pm
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/Task/NetDiscovery.pm
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/SNMP.pm
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/SNMP

%files task-esx
%defattr(-,root,root)
%{_bindir}/fusioninventory-esx
%{_mandir}/man1/fusioninventory-esx.1*
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/Task/ESX.pm
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/SOAP

%files task-deploy
%defattr(-,root,root)
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/Task/Deploy.pm
%{_datadir}/fusioninventory/lib/FusionInventory/Agent/Task/Deploy

%changelog
*Tue May 26 2015 Kevin COUSIN <kcousin@globalsp.com> 2.3.16-2
- Patch to index oVirt VM, see http://forge.fusioninventory.org/issues/2917

*Tue May 26 2015 Kevin COUSIN <kcousin@globalsp.com> 2.3.16-1
- Upgrate to 2.3.16

*Thu Dec 11 2014 Kevin COUSIN <kcousin@globalsp.com> 2.3.12-2
- Upgrade for Fedora 21

*Mon Oct 27 2014 Kevin COUSIN <kcousin@globalsp.com> 2.3.12-1
- Update to 2.3.12

*Fri Jul 11 2014 Kevin COUSIN <kcousin@globalsp.com> 2.3.6-4
- Fix adding service file for EL 7

*Fri Jul 11 2014 Kevin COUSIN <kcousin@globalsp.com> 2.3.6-3
- Rebuild for EL7

*Mon Apr 07 2014 Kevin COUSIN <kcousin@globalsp.com> 2.3.6-2
- Fix init file

* Mon Apr 07 2014 Kevin COUSIN <kcousin@globalsp.com> 2.3.6-1
- Update to 2.3.6
- create an update spec file to build on  el and Fedora

* Mon Feb 17 2014 Kevin COUSIN <kcousin@globalsp.com> 2.3.5.1-5
- Fix SPEC File
- Obsoletes FusionInventory-Agent-Agent perl-FusionInventory-Agent-Task-Network perl-FusionInventory-Agent-Task-ESX perl-FusionInventory-Agent-Task-Deply

* Tue Jan 28 2014 Kevin COUSIN <kcousin@globalsp.com> 2.3.5.1-4
- Fix systemd service file

* Tue Jan 28 2014 Kevin COUSIN <kcousin@globalsp.com> 2.3.5.1-3
- Remove init script and add systemd service file

* Mon Jan 27 2014 Kevin COUSIN <kcousin@globalsp.com> 2.3.5.1-2
- Fedora build 

* Wed Jan 15 2014 Guillaume Rousse <guillomovitch@gmail.com> 2.3.5.1-1
- update to 2.3.5.1

* Fri Nov 29 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.3.4-1
- update to 2.3.4

* Wed Nov 06 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.3.3-1
- update to 2.3.3

* Tue Oct 08 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.3.2-1
- update to 2.3.2

* Tue Sep 10 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.3.1-1
- update to 2.3.1

* Thu Aug 08 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.3.0-5
- list optional suggested packages in descriptions
  
* Wed Aug 07 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.3.0-4
- add optional perl modules needed for daemon mode as explicit dependencies
  (#2195)

* Tue Aug 06 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.3.0-3
- really move F::A::HTTP::Client::Fusion class in main package
- move executable man pages in various task packages
  
* Mon Aug 05 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.3.0-2
- better description
- move F::A::HTTP::Client::Fusion class in main package, it is needed
  both for esx and deploy tasks

* Thu Aug 01 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.3.0-1
- update to 2.3.0
- drop suse conditional build statements, as there no interest to make
  spec file more complex, without any way to test the result

* Tue Feb 12 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.2.7-2
- first attempt to port it to Suse
- fix perms and name of init script

* Fri Jan 11 2013 Guillaume Rousse <guillomovitch@gmail.com> 2.2.7-1
- initial OBS release
